import { useSpinButton } from "@react-aria/spinbutton";
import { MessageDictionary } from "@internationalized/message";
import _react, { useMemo, useRef } from "react";
import { NumberParser } from "@internationalized/number";
import { useLocale, useMessageFormatter, useDateFormatter, useFilter } from "@react-aria/i18n";
import { useField } from "@react-aria/label";
import { usePress, useFocusWithin } from "@react-aria/interactions";
import { mergeProps, useDescription, useId, getScrollParent, isIOS, isMac, scrollIntoView, useEvent, useLabels } from "@react-aria/utils";
import { createFocusManager, useFocusManager } from "@react-aria/focus";
import _babelRuntimeHelpersEsmInteropRequireDefault from "@babel/runtime/helpers/esm/interopRequireDefault";
import _babelRuntimeHelpersEsmExtends from "@babel/runtime/helpers/esm/extends";
// ASSET: /home/circleci/react-spectrum/packages/@react-aria/datepicker/intl/ar-AE.json
var $b935bd0cd08a5bbbb1abd3806a771dc4$exports = {};
$b935bd0cd08a5bbbb1abd3806a771dc4$exports = JSON.parse("{\"calendar\":\"التقويم\",\"currentDate\":\"{date, date, full}\",\"currentDateRange\":\"{start, date, long} إلى {end, date, long}\",\"date\":\"التاريخ\",\"dateRange\":\"نطاق التاريخ\",\"day\":\"يوم\",\"dayPeriod\":\"ص/م\",\"endDate\":\"تاريخ الانتهاء\",\"era\":\"العصر\",\"hour\":\"الساعات\",\"minute\":\"الدقائق\",\"month\":\"الشهر\",\"second\":\"الثواني\",\"startDate\":\"تاريخ البدء\",\"year\":\"السنة\",\"weekday\":\"اليوم\",\"timeZoneName\":\"التوقيت\"}");
// ASSET: /home/circleci/react-spectrum/packages/@react-aria/datepicker/intl/bg-BG.json
var $fd4c1baa70755ee27b55d9d185ef9a9$exports = {};
$fd4c1baa70755ee27b55d9d185ef9a9$exports = JSON.parse("{\"calendar\":\"Календар\",\"currentDate\":\"{date, date, full}\",\"currentDateRange\":\"{start, date, long} до {end, date, long}\",\"date\":\"Дата\",\"dateRange\":\"Времеви интервал\",\"day\":\"ден\",\"dayPeriod\":\"пр.об./сл.об.\",\"endDate\":\"Крайна дата\",\"era\":\"ера\",\"hour\":\"час\",\"minute\":\"минута\",\"month\":\"месец\",\"second\":\"секунда\",\"startDate\":\"Начална дата\",\"year\":\"година\",\"weekday\":\"ден от седмицата\",\"timeZoneName\":\"часова зона\"}");
// ASSET: /home/circleci/react-spectrum/packages/@react-aria/datepicker/intl/cs-CZ.json
var $ec5372c287a16045d039aa0470ed9fb2$exports = {};
$ec5372c287a16045d039aa0470ed9fb2$exports = JSON.parse("{\"calendar\":\"Kalendář\",\"currentDate\":\"{date, date, full}\",\"currentDateRange\":\"{start, date, long} až {end, date, long}\",\"date\":\"Datum\",\"dateRange\":\"Rozsah dat\",\"day\":\"den\",\"dayPeriod\":\"část dne\",\"endDate\":\"Konečné datum\",\"era\":\"letopočet\",\"hour\":\"hodina\",\"minute\":\"minuta\",\"month\":\"měsíc\",\"second\":\"sekunda\",\"startDate\":\"Počáteční datum\",\"year\":\"rok\",\"weekday\":\"den v týdnu\",\"timeZoneName\":\"časové pásmo\"}");
// ASSET: /home/circleci/react-spectrum/packages/@react-aria/datepicker/intl/da-DK.json
var $f6d6f24ad9d284dd48723518690d0e39$exports = {};
$f6d6f24ad9d284dd48723518690d0e39$exports = JSON.parse("{\"calendar\":\"Kalender\",\"currentDate\":\"{date, date, full}\",\"currentDateRange\":\"{start, date, long} til {end, date, long}\",\"date\":\"Dato\",\"dateRange\":\"Datointerval\",\"day\":\"dag\",\"dayPeriod\":\"AM/PM\",\"endDate\":\"Slutdato\",\"era\":\"æra\",\"hour\":\"time\",\"minute\":\"minut\",\"month\":\"måned\",\"second\":\"sekund\",\"startDate\":\"Startdato\",\"year\":\"år\",\"weekday\":\"ugedag\",\"timeZoneName\":\"tidszone\"}");
// ASSET: /home/circleci/react-spectrum/packages/@react-aria/datepicker/intl/de-DE.json
var $cc3534ef504f0b7371d8c5aa254d877f$exports = {};
$cc3534ef504f0b7371d8c5aa254d877f$exports = JSON.parse("{\"calendar\":\"Kalender\",\"currentDate\":\"{date, date, full}\",\"currentDateRange\":\"{start, date, long} bis {end, date, long}\",\"date\":\"Datum\",\"dateRange\":\"Datumsbereich\",\"day\":\"Tag\",\"dayPeriod\":\"Tageshälfte\",\"endDate\":\"Enddatum\",\"era\":\"Epoche\",\"hour\":\"Stunde\",\"minute\":\"Minute\",\"month\":\"Monat\",\"second\":\"Sekunde\",\"startDate\":\"Anfangsdatum\",\"year\":\"Jahr\",\"weekday\":\"Wochentag\",\"timeZoneName\":\"Zeitzone\"}");
// ASSET: /home/circleci/react-spectrum/packages/@react-aria/datepicker/intl/el-GR.json
var $ebc142984d7760b9cffe23548bb$exports = {};
$ebc142984d7760b9cffe23548bb$exports = JSON.parse("{\"calendar\":\"Ημερολόγιο\",\"currentDate\":\"{date, date, full}\",\"currentDateRange\":\"{start, date, long} ως {end, date, long}\",\"date\":\"Ημερομηνία\",\"dateRange\":\"Εύρος ημερομηνιών\",\"day\":\"ημέρα\",\"dayPeriod\":\"π.μ./μ.μ.\",\"endDate\":\"Ημερομηνία λήξης\",\"era\":\"περίοδος\",\"hour\":\"ώρα\",\"minute\":\"λεπτό\",\"month\":\"μήνας\",\"second\":\"δευτερόλεπτο\",\"startDate\":\"Ημερομηνία έναρξης\",\"year\":\"έτος\",\"weekday\":\"καθημερινή\",\"timeZoneName\":\"ζώνη ώρας\"}");
// ASSET: /home/circleci/react-spectrum/packages/@react-aria/datepicker/intl/en-US.json
var $f9cbab65725c7cb01e69dde93bd9a$exports = {};
$f9cbab65725c7cb01e69dde93bd9a$exports = JSON.parse("{\"era\":\"era\",\"year\":\"year\",\"month\":\"month\",\"day\":\"day\",\"hour\":\"hour\",\"minute\":\"minute\",\"second\":\"second\",\"dayPeriod\":\"AM/PM\",\"calendar\":\"Calendar\",\"date\":\"Date\",\"dateRange\":\"Date Range\",\"startDate\":\"Start Date\",\"endDate\":\"End Date\",\"currentDate\":\"{date, date, full}\",\"currentDateRange\":\"{start, date, long} to {end, date, long}\",\"weekday\":\"day of the week\",\"timeZoneName\":\"time zone\"}");
// ASSET: /home/circleci/react-spectrum/packages/@react-aria/datepicker/intl/es-ES.json
var $b069706710aa3fdbaa20a1b3449d63$exports = {};
$b069706710aa3fdbaa20a1b3449d63$exports = JSON.parse("{\"calendar\":\"Calendario\",\"currentDate\":\"{date, date, full}\",\"currentDateRange\":\"{start, date, long} a {end, date, long}\",\"date\":\"Fecha\",\"dateRange\":\"Intervalo de fecha\",\"day\":\"día\",\"dayPeriod\":\"a. m./p. m.\",\"endDate\":\"Fecha final\",\"era\":\"era\",\"hour\":\"hora\",\"minute\":\"minuto\",\"month\":\"mes\",\"second\":\"segundo\",\"startDate\":\"Fecha de inicio\",\"year\":\"año\",\"weekday\":\"día de la semana\",\"timeZoneName\":\"zona horaria\"}");
// ASSET: /home/circleci/react-spectrum/packages/@react-aria/datepicker/intl/et-EE.json
var $dc294c753448ff9c1809bca75ab74d1$exports = {};
$dc294c753448ff9c1809bca75ab74d1$exports = JSON.parse("{\"calendar\":\"Kalender\",\"currentDate\":\"{date, date, full}\",\"currentDateRange\":\"{start, date, long} kuni {end, date, long}\",\"date\":\"Kuupäev\",\"dateRange\":\"Kuupäevavahemik\",\"day\":\"päev\",\"dayPeriod\":\"enne/pärast lõunat\",\"endDate\":\"Lõppkuupäev\",\"era\":\"ajastu\",\"hour\":\"tund\",\"minute\":\"minut\",\"month\":\"kuu\",\"second\":\"sekund\",\"startDate\":\"Alguskuupäev\",\"year\":\"aasta\",\"weekday\":\"nädalapäev\",\"timeZoneName\":\"ajavöönd\"}");
// ASSET: /home/circleci/react-spectrum/packages/@react-aria/datepicker/intl/fi-FI.json
var $d3f5f76480327eda035ed93c2$exports = {};
$d3f5f76480327eda035ed93c2$exports = JSON.parse("{\"calendar\":\"Kalenteri\",\"currentDate\":\"{date, date, full}\",\"currentDateRange\":\"{start, date, long}–{end, date, long}\",\"date\":\"Päivämäärä\",\"dateRange\":\"Päivämääräalue\",\"day\":\"päivä\",\"dayPeriod\":\"vuorokaudenaika\",\"endDate\":\"Päättymispäivä\",\"era\":\"aikakausi\",\"hour\":\"tunti\",\"minute\":\"minuutti\",\"month\":\"kuukausi\",\"second\":\"sekunti\",\"startDate\":\"Alkamispäivä\",\"year\":\"vuosi\",\"weekday\":\"viikonpäivä\",\"timeZoneName\":\"aikavyöhyke\"}");
// ASSET: /home/circleci/react-spectrum/packages/@react-aria/datepicker/intl/fr-FR.json
var $b627132da032b4209b5582508dfe332$exports = {};
$b627132da032b4209b5582508dfe332$exports = JSON.parse("{\"calendar\":\"Calendrier\",\"currentDate\":\"{date, date, full}\",\"currentDateRange\":\"{start, date, long} au {end, date, long}\",\"date\":\"Date\",\"dateRange\":\"Plage de dates\",\"day\":\"jour\",\"dayPeriod\":\"cadran\",\"endDate\":\"Date de fin\",\"era\":\"ère\",\"hour\":\"heure\",\"minute\":\"minute\",\"month\":\"mois\",\"second\":\"seconde\",\"startDate\":\"Date de début\",\"year\":\"année\",\"weekday\":\"jour de la semaine\",\"timeZoneName\":\"fuseau horaire\"}");
// ASSET: /home/circleci/react-spectrum/packages/@react-aria/datepicker/intl/he-IL.json
var $c3959c7b2e7e08ef514631ba3c2fdb$exports = {};
$c3959c7b2e7e08ef514631ba3c2fdb$exports = JSON.parse("{\"calendar\":\"לוח שנה\",\"currentDate\":\"{date, date, full}\",\"currentDateRange\":\"מ-{start, date, long} ועד {end, date, long}\",\"date\":\"תאריך\",\"dateRange\":\"טווח תאריכים\",\"day\":\"יום\",\"dayPeriod\":\"לפנה״צ/אחה״צ\",\"endDate\":\"תאריך סיום\",\"era\":\"תקופה\",\"hour\":\"שעה\",\"minute\":\"דקה\",\"month\":\"חודש\",\"second\":\"שנייה\",\"startDate\":\"תאריך התחלה\",\"year\":\"שנה\",\"weekday\":\"יום בשבוע\",\"timeZoneName\":\"אזור זמן\"}");
// ASSET: /home/circleci/react-spectrum/packages/@react-aria/datepicker/intl/hr-HR.json
var $ca3a95147a2664e1a3c49130ccfb87$exports = {};
$ca3a95147a2664e1a3c49130ccfb87$exports = JSON.parse("{\"calendar\":\"Kalendar\",\"currentDate\":\"{date, date, full}\",\"currentDateRange\":\"{start, date, long} do {end, date, long}\",\"date\":\"Datum\",\"dateRange\":\"Raspon datuma\",\"day\":\"dan\",\"dayPeriod\":\"AM/PM\",\"endDate\":\"Datum završetka\",\"era\":\"era\",\"hour\":\"sat\",\"minute\":\"minuta\",\"month\":\"mjesec\",\"second\":\"sekunda\",\"startDate\":\"Datum početka\",\"year\":\"godina\",\"weekday\":\"dan u tjednu\",\"timeZoneName\":\"vremenska zona\"}");
// ASSET: /home/circleci/react-spectrum/packages/@react-aria/datepicker/intl/hu-HU.json
var $fa6b6e78fd909c4deb0805c4ff5df60$exports = {};
$fa6b6e78fd909c4deb0805c4ff5df60$exports = JSON.parse("{\"calendar\":\"Naptár\",\"currentDate\":\"{date, date, full}\",\"currentDateRange\":\"{start, date, long} – {end, date, long}\",\"date\":\"Dátum\",\"dateRange\":\"Dátumtartomány\",\"day\":\"nap\",\"dayPeriod\":\"napszak\",\"endDate\":\"Befejező dátum\",\"era\":\"éra\",\"hour\":\"óra\",\"minute\":\"perc\",\"month\":\"hónap\",\"second\":\"másodperc\",\"startDate\":\"Kezdő dátum\",\"year\":\"év\",\"weekday\":\"hét napja\",\"timeZoneName\":\"időzóna\"}");
// ASSET: /home/circleci/react-spectrum/packages/@react-aria/datepicker/intl/it-IT.json
var $bb4837487a35e965bc77709590fda45$exports = {};
$bb4837487a35e965bc77709590fda45$exports = JSON.parse("{\"calendar\":\"Calendario\",\"currentDate\":\"{date, date, full}\",\"currentDateRange\":\"Da {start, date, long} a {end, date, long}\",\"date\":\"Data\",\"dateRange\":\"Intervallo date\",\"day\":\"giorno\",\"dayPeriod\":\"AM/PM\",\"endDate\":\"Data finale\",\"era\":\"era\",\"hour\":\"ora\",\"minute\":\"minuto\",\"month\":\"mese\",\"second\":\"secondo\",\"startDate\":\"Data iniziale\",\"year\":\"anno\",\"weekday\":\"giorno della settimana\",\"timeZoneName\":\"fuso orario\"}");
// ASSET: /home/circleci/react-spectrum/packages/@react-aria/datepicker/intl/ja-JP.json
var $f021a923ac58a1406a8f3f0bfd5f718$exports = {};
$f021a923ac58a1406a8f3f0bfd5f718$exports = JSON.parse("{\"calendar\":\"カレンダー\",\"currentDate\":\"{date, date, full}\",\"currentDateRange\":\"{start, date, long} ～ {end, date, long}\",\"date\":\"日付\",\"dateRange\":\"日付範囲\",\"day\":\"日\",\"dayPeriod\":\"午前/午後\",\"endDate\":\"終了日\",\"era\":\"時代\",\"hour\":\"時\",\"minute\":\"分\",\"month\":\"月\",\"second\":\"秒\",\"startDate\":\"開始日\",\"year\":\"年\",\"weekday\":\"曜日\",\"timeZoneName\":\"タイムゾーン\"}");
// ASSET: /home/circleci/react-spectrum/packages/@react-aria/datepicker/intl/ko-KR.json
var $e1a2895f7736c57623c5df88ed61$exports = {};
$e1a2895f7736c57623c5df88ed61$exports = JSON.parse("{\"calendar\":\"달력\",\"currentDate\":\"{date, date, full}\",\"currentDateRange\":\"{start, date, long} ~ {end, date, long}\",\"date\":\"날짜\",\"dateRange\":\"날짜 범위\",\"day\":\"일\",\"dayPeriod\":\"오전/오후\",\"endDate\":\"종료 날짜\",\"era\":\"연호\",\"hour\":\"시\",\"minute\":\"분\",\"month\":\"월\",\"second\":\"초\",\"startDate\":\"시작 날짜\",\"year\":\"년\",\"weekday\":\"요일\",\"timeZoneName\":\"시간대\"}");
// ASSET: /home/circleci/react-spectrum/packages/@react-aria/datepicker/intl/lt-LT.json
var $ee477dd4ee39b2586e7d93e4241$exports = {};
$ee477dd4ee39b2586e7d93e4241$exports = JSON.parse("{\"calendar\":\"Kalendorius\",\"currentDate\":\"{date, date, full}\",\"currentDateRange\":\"Nuo {start, date, long} iki {end, date, long}\",\"date\":\"Data\",\"dateRange\":\"Datų intervalas\",\"day\":\"diena\",\"dayPeriod\":\"iki pietų / po pietų\",\"endDate\":\"Pabaigos data\",\"era\":\"era\",\"hour\":\"valanda\",\"minute\":\"minutė\",\"month\":\"mėnuo\",\"second\":\"sekundė\",\"startDate\":\"Pradžios data\",\"year\":\"metai\",\"weekday\":\"savaitės diena\",\"timeZoneName\":\"laiko juosta\"}");
// ASSET: /home/circleci/react-spectrum/packages/@react-aria/datepicker/intl/lv-LV.json
var $c216567e87e3bd12ecb2f27ce189a5b$exports = {};
$c216567e87e3bd12ecb2f27ce189a5b$exports = JSON.parse("{\"calendar\":\"Kalendārs\",\"currentDate\":\"{date, date, full}\",\"currentDateRange\":\"{start, date, long} līdz {end, date, long}\",\"date\":\"Datums\",\"dateRange\":\"Datumu diapazons\",\"day\":\"diena\",\"dayPeriod\":\"priekšpusdienā/pēcpusdienā\",\"endDate\":\"Beigu datums\",\"era\":\"ēra\",\"hour\":\"stundas\",\"minute\":\"minūtes\",\"month\":\"mēnesis\",\"second\":\"sekundes\",\"startDate\":\"Sākuma datums\",\"year\":\"gads\",\"weekday\":\"nedēļas diena\",\"timeZoneName\":\"laika josla\"}");
// ASSET: /home/circleci/react-spectrum/packages/@react-aria/datepicker/intl/nb-NO.json
var $d57cd730bb11b14bdcd692e702bb0e60$exports = {};
$d57cd730bb11b14bdcd692e702bb0e60$exports = JSON.parse("{\"calendar\":\"Kalender\",\"currentDate\":\"{date, date, full}\",\"currentDateRange\":\"{start, date, long} til {end, date, long}\",\"date\":\"Dato\",\"dateRange\":\"Datoområde\",\"day\":\"dag\",\"dayPeriod\":\"a.m./p.m.\",\"endDate\":\"Sluttdato\",\"era\":\"tidsalder\",\"hour\":\"time\",\"minute\":\"minutt\",\"month\":\"måned\",\"second\":\"sekund\",\"startDate\":\"Startdato\",\"year\":\"år\",\"weekday\":\"ukedag\",\"timeZoneName\":\"tidssone\"}");
// ASSET: /home/circleci/react-spectrum/packages/@react-aria/datepicker/intl/nl-NL.json
var $bd8f8fc2a02532c55851f18c8de3$exports = {};
$bd8f8fc2a02532c55851f18c8de3$exports = JSON.parse("{\"calendar\":\"Kalender\",\"currentDate\":\"{date, date, full}\",\"currentDateRange\":\"{start, date, long} t/m {end, date, long}\",\"date\":\"Datum\",\"dateRange\":\"Datumbereik\",\"day\":\"dag\",\"dayPeriod\":\"a.m./p.m.\",\"endDate\":\"Einddatum\",\"era\":\"tijdperk\",\"hour\":\"uur\",\"minute\":\"minuut\",\"month\":\"maand\",\"second\":\"seconde\",\"startDate\":\"Startdatum\",\"year\":\"jaar\",\"weekday\":\"dag van de week\",\"timeZoneName\":\"tijdzone\"}");
// ASSET: /home/circleci/react-spectrum/packages/@react-aria/datepicker/intl/pl-PL.json
var $d8e1a561b4b79d4ead55e4ee5ea09970$exports = {};
$d8e1a561b4b79d4ead55e4ee5ea09970$exports = JSON.parse("{\"calendar\":\"Kalendarz\",\"currentDate\":\"{date, date, full}\",\"currentDateRange\":\"{start, date, long} do {end, date, long}\",\"date\":\"Data\",\"dateRange\":\"Zakres dat\",\"day\":\"dzień\",\"dayPeriod\":\"rano / po południu / wieczorem\",\"endDate\":\"Data końcowa\",\"era\":\"era\",\"hour\":\"godzina\",\"minute\":\"minuta\",\"month\":\"miesiąc\",\"second\":\"sekunda\",\"startDate\":\"Data początkowa\",\"year\":\"rok\",\"weekday\":\"dzień tygodnia\",\"timeZoneName\":\"strefa czasowa\"}");
// ASSET: /home/circleci/react-spectrum/packages/@react-aria/datepicker/intl/pt-BR.json
var $d479a80df73293910fe373596d18f$exports = {};
$d479a80df73293910fe373596d18f$exports = JSON.parse("{\"calendar\":\"Calendário\",\"currentDate\":\"{date, date, full}\",\"currentDateRange\":\"{start, date, long} a {end, date, long}\",\"date\":\"Data\",\"dateRange\":\"Intervalo de datas\",\"day\":\"dia\",\"dayPeriod\":\"AM/PM\",\"endDate\":\"Data final\",\"era\":\"era\",\"hour\":\"hora\",\"minute\":\"minuto\",\"month\":\"mês\",\"second\":\"segundo\",\"startDate\":\"Data inicial\",\"year\":\"ano\",\"weekday\":\"dia da semana\",\"timeZoneName\":\"fuso horário\"}");
// ASSET: /home/circleci/react-spectrum/packages/@react-aria/datepicker/intl/pt-PT.json
var $d91b847a2bf9b6fb7cc187d839c725f$exports = {};
$d91b847a2bf9b6fb7cc187d839c725f$exports = JSON.parse("{\"calendar\":\"Calendário\",\"currentDate\":\"{date, date, full}\",\"currentDateRange\":\"{start, date, long} a {end, date, long}\",\"date\":\"Data\",\"dateRange\":\"Intervalo de datas\",\"day\":\"dia\",\"dayPeriod\":\"am/pm\",\"endDate\":\"Data de Término\",\"era\":\"era\",\"hour\":\"hora\",\"minute\":\"minuto\",\"month\":\"mês\",\"second\":\"segundo\",\"startDate\":\"Data de Início\",\"year\":\"ano\",\"weekday\":\"dia da semana\",\"timeZoneName\":\"fuso horário\"}");
// ASSET: /home/circleci/react-spectrum/packages/@react-aria/datepicker/intl/ro-RO.json
var $f25e8d5f5e9099b97d639d4f299ba$exports = {};
$f25e8d5f5e9099b97d639d4f299ba$exports = JSON.parse("{\"calendar\":\"Calendar\",\"currentDate\":\"{date, date, full}\",\"currentDateRange\":\"{start, date, long} - {end, date, long}\",\"date\":\"Dată\",\"dateRange\":\"Raza datei\",\"day\":\"zi\",\"dayPeriod\":\"a.m/p.m.\",\"endDate\":\"Dată final\",\"era\":\"eră\",\"hour\":\"oră\",\"minute\":\"minut\",\"month\":\"lună\",\"second\":\"secundă\",\"startDate\":\"Dată început\",\"year\":\"an\",\"weekday\":\"ziua din săptămână\",\"timeZoneName\":\"fus orar\"}");
// ASSET: /home/circleci/react-spectrum/packages/@react-aria/datepicker/intl/ru-RU.json
var $da94598d7d1c854d87360883488$exports = {};
$da94598d7d1c854d87360883488$exports = JSON.parse("{\"calendar\":\"Календарь\",\"currentDate\":\"{date, date, full}\",\"currentDateRange\":\"{start, date, long} – {end, date, long}\",\"date\":\"Дата\",\"dateRange\":\"Диапазон дат\",\"day\":\"день\",\"dayPeriod\":\"AM/PM\",\"endDate\":\"Дата окончания\",\"era\":\"эра\",\"hour\":\"час\",\"minute\":\"минута\",\"month\":\"месяц\",\"second\":\"секунда\",\"startDate\":\"Дата начала\",\"year\":\"год\",\"weekday\":\"день недели\",\"timeZoneName\":\"часовой пояс\"}");
// ASSET: /home/circleci/react-spectrum/packages/@react-aria/datepicker/intl/sk-SK.json
var $d1513dad87da1caa61156c979822ded2$exports = {};
$d1513dad87da1caa61156c979822ded2$exports = JSON.parse("{\"calendar\":\"Kalendár\",\"currentDate\":\"{date, date, full}\",\"currentDateRange\":\"{start, date, long} do {end, date, long}\",\"date\":\"Dátum\",\"dateRange\":\"Rozsah dátumov\",\"day\":\"deň\",\"dayPeriod\":\"AM/PM\",\"endDate\":\"Dátum ukončenia\",\"era\":\"letopočet\",\"hour\":\"hodina\",\"minute\":\"minúta\",\"month\":\"mesiac\",\"second\":\"sekunda\",\"startDate\":\"Dátum začatia\",\"year\":\"rok\",\"weekday\":\"deň týždňa\",\"timeZoneName\":\"časové pásmo\"}");
// ASSET: /home/circleci/react-spectrum/packages/@react-aria/datepicker/intl/sl-SI.json
var $e16512e37a1c3ef90ecfc72d16793c1$exports = {};
$e16512e37a1c3ef90ecfc72d16793c1$exports = JSON.parse("{\"calendar\":\"Koledar\",\"currentDate\":\"{date, date, full}\",\"currentDateRange\":\"{start, date, long} do {end, date, long}\",\"date\":\"Datum\",\"dateRange\":\"Datumski obseg\",\"day\":\"dan\",\"dayPeriod\":\"dop/pop\",\"endDate\":\"Datum konca\",\"era\":\"doba\",\"hour\":\"ura\",\"minute\":\"minuta\",\"month\":\"mesec\",\"second\":\"sekunda\",\"startDate\":\"Datum začetka\",\"year\":\"leto\",\"weekday\":\"dan v tednu\",\"timeZoneName\":\"časovni pas\"}");
// ASSET: /home/circleci/react-spectrum/packages/@react-aria/datepicker/intl/sr-SP.json
var $f0f0ea292848c1c22e92d1c71347950$exports = {};
$f0f0ea292848c1c22e92d1c71347950$exports = JSON.parse("{\"calendar\":\"Kalendar\",\"currentDate\":\"{date, date, full}\",\"currentDateRange\":\"{start, date, long} do {end, date, long}\",\"date\":\"Datum\",\"dateRange\":\"Opseg datuma\",\"day\":\"дан\",\"dayPeriod\":\"пре подне/по подне\",\"endDate\":\"Datum završetka\",\"era\":\"ера\",\"hour\":\"сат\",\"minute\":\"минут\",\"month\":\"месец\",\"second\":\"секунд\",\"startDate\":\"Datum početka\",\"year\":\"година\",\"weekday\":\"дан у недељи\",\"timeZoneName\":\"временска зона\"}");
// ASSET: /home/circleci/react-spectrum/packages/@react-aria/datepicker/intl/sv-SE.json
var $ddeb3363257d0b1fab7fb0169309987$exports = {};
$ddeb3363257d0b1fab7fb0169309987$exports = JSON.parse("{\"calendar\":\"Kalender\",\"currentDate\":\"{date, date, full}\",\"currentDateRange\":\"{start, date, long} till {end, date, long}\",\"date\":\"Datum\",\"dateRange\":\"Datumintervall\",\"day\":\"dag\",\"dayPeriod\":\"fm/em\",\"endDate\":\"Slutdatum\",\"era\":\"era\",\"hour\":\"timme\",\"minute\":\"minut\",\"month\":\"månad\",\"second\":\"sekund\",\"startDate\":\"Startdatum\",\"year\":\"år\",\"weekday\":\"veckodag\",\"timeZoneName\":\"tidszon\"}");
// ASSET: /home/circleci/react-spectrum/packages/@react-aria/datepicker/intl/tr-TR.json
var $e41e18d940cc1fd6ce3b548eaf26f$exports = {};
$e41e18d940cc1fd6ce3b548eaf26f$exports = JSON.parse("{\"calendar\":\"Takvim\",\"currentDate\":\"{date, date, full}\",\"currentDateRange\":\"{start, date, long} - {end, date, long}\",\"date\":\"Tarih\",\"dateRange\":\"Tarih Aralığı\",\"day\":\"gün\",\"dayPeriod\":\"ÖÖ/ÖS\",\"endDate\":\"Bitiş Tarihi\",\"era\":\"çağ\",\"hour\":\"saat\",\"minute\":\"dakika\",\"month\":\"ay\",\"second\":\"saniye\",\"startDate\":\"Başlangıç Tarihi\",\"year\":\"yıl\",\"weekday\":\"haftanın günü\",\"timeZoneName\":\"saat dilimi\"}");
// ASSET: /home/circleci/react-spectrum/packages/@react-aria/datepicker/intl/uk-UA.json
var $c7fbfea59f1f84c3fbdb550bd45e1a8d$exports = {};
$c7fbfea59f1f84c3fbdb550bd45e1a8d$exports = JSON.parse("{\"calendar\":\"Календар\",\"currentDate\":\"{date, date, full}\",\"currentDateRange\":\"Від {start, date, long} до {end, date, long}\",\"date\":\"Дата\",\"dateRange\":\"Діапазон дат\",\"day\":\"день\",\"dayPeriod\":\"дп/пп\",\"endDate\":\"Дата завершення\",\"era\":\"ера\",\"hour\":\"година\",\"minute\":\"хвилина\",\"month\":\"місяць\",\"second\":\"секунда\",\"startDate\":\"Дата початку\",\"year\":\"рік\",\"weekday\":\"день тижня\",\"timeZoneName\":\"часовий пояс\"}");
// ASSET: /home/circleci/react-spectrum/packages/@react-aria/datepicker/intl/zh-CN.json
var $c5ee38283255212ee41b3baf5b8304d$exports = {};
$c5ee38283255212ee41b3baf5b8304d$exports = JSON.parse("{\"calendar\":\"日历\",\"currentDate\":\"{date, date, full}\",\"currentDateRange\":\"{start, date, long} 至 {end, date, long}\",\"date\":\"日期\",\"dateRange\":\"日期范围\",\"day\":\"日\",\"dayPeriod\":\"上午/下午\",\"endDate\":\"结束日期\",\"era\":\"纪元\",\"hour\":\"小时\",\"minute\":\"分钟\",\"month\":\"月\",\"second\":\"秒\",\"startDate\":\"开始日期\",\"year\":\"年\",\"weekday\":\"工作日\",\"timeZoneName\":\"时区\"}");
// ASSET: /home/circleci/react-spectrum/packages/@react-aria/datepicker/intl/zh-TW.json
var $e4f38d4b06a7a74952e9f6dec2e6e20$exports = {};
$e4f38d4b06a7a74952e9f6dec2e6e20$exports = JSON.parse("{\"calendar\":\"日曆\",\"currentDate\":\"{date, date, full}\",\"currentDateRange\":\"{start, date, long}至 {end, date, long}\",\"date\":\"日期\",\"dateRange\":\"日期範圍\",\"day\":\"日\",\"dayPeriod\":\"上午/下午\",\"endDate\":\"結束日期\",\"era\":\"纪元\",\"hour\":\"小时\",\"minute\":\"分钟\",\"month\":\"月\",\"second\":\"秒\",\"startDate\":\"開始日期\",\"year\":\"年\",\"weekday\":\"工作日\",\"timeZoneName\":\"时区\"}");

function $bf15f790f1b0bea8ba7f44d4056d095d$export$useDatePickerGroup(state, ref) {
  // Open the popover on alt + arrow down
  let onKeyDown = e => {
    if (e.altKey && e.key === 'ArrowDown' && 'setOpen' in state) {
      e.preventDefault();
      e.stopPropagation();
      state.setOpen(true);
    }
  }; // Focus the first placeholder segment from the end on mouse down/touch up in the field.


  let focusLast = () => {
    let elements = ref.current.querySelectorAll('[tabindex="0"]');
    let index = elements.length - 1;

    while (index >= 0 && elements[index].getAttribute('aria-placeholder')) {
      index--;
    }

    index = Math.min(index + 1, elements.length - 1);
    let element = elements[index];

    if (element) {
      element.focus();
    }
  };

  let {
    pressProps
  } = usePress({
    onPressStart(e) {
      if (e.pointerType === 'mouse') {
        focusLast();
      }
    },

    onPress(e) {
      if (e.pointerType !== 'mouse') {
        focusLast();
      }
    }

  });
  return mergeProps(pressProps, {
    onKeyDown
  });
}

// @ts-ignore
const $c154dc72a1c6e7eac4dc4005915dd53b$var$intlMessages = {
  "ar-AE": _babelRuntimeHelpersEsmInteropRequireDefault($b935bd0cd08a5bbbb1abd3806a771dc4$exports).default,
  "bg-BG": _babelRuntimeHelpersEsmInteropRequireDefault($fd4c1baa70755ee27b55d9d185ef9a9$exports).default,
  "cs-CZ": _babelRuntimeHelpersEsmInteropRequireDefault($ec5372c287a16045d039aa0470ed9fb2$exports).default,
  "da-DK": _babelRuntimeHelpersEsmInteropRequireDefault($f6d6f24ad9d284dd48723518690d0e39$exports).default,
  "de-DE": _babelRuntimeHelpersEsmInteropRequireDefault($cc3534ef504f0b7371d8c5aa254d877f$exports).default,
  "el-GR": _babelRuntimeHelpersEsmInteropRequireDefault($ebc142984d7760b9cffe23548bb$exports).default,
  "en-US": _babelRuntimeHelpersEsmInteropRequireDefault($f9cbab65725c7cb01e69dde93bd9a$exports).default,
  "es-ES": _babelRuntimeHelpersEsmInteropRequireDefault($b069706710aa3fdbaa20a1b3449d63$exports).default,
  "et-EE": _babelRuntimeHelpersEsmInteropRequireDefault($dc294c753448ff9c1809bca75ab74d1$exports).default,
  "fi-FI": _babelRuntimeHelpersEsmInteropRequireDefault($d3f5f76480327eda035ed93c2$exports).default,
  "fr-FR": _babelRuntimeHelpersEsmInteropRequireDefault($b627132da032b4209b5582508dfe332$exports).default,
  "he-IL": _babelRuntimeHelpersEsmInteropRequireDefault($c3959c7b2e7e08ef514631ba3c2fdb$exports).default,
  "hr-HR": _babelRuntimeHelpersEsmInteropRequireDefault($ca3a95147a2664e1a3c49130ccfb87$exports).default,
  "hu-HU": _babelRuntimeHelpersEsmInteropRequireDefault($fa6b6e78fd909c4deb0805c4ff5df60$exports).default,
  "it-IT": _babelRuntimeHelpersEsmInteropRequireDefault($bb4837487a35e965bc77709590fda45$exports).default,
  "ja-JP": _babelRuntimeHelpersEsmInteropRequireDefault($f021a923ac58a1406a8f3f0bfd5f718$exports).default,
  "ko-KR": _babelRuntimeHelpersEsmInteropRequireDefault($e1a2895f7736c57623c5df88ed61$exports).default,
  "lt-LT": _babelRuntimeHelpersEsmInteropRequireDefault($ee477dd4ee39b2586e7d93e4241$exports).default,
  "lv-LV": _babelRuntimeHelpersEsmInteropRequireDefault($c216567e87e3bd12ecb2f27ce189a5b$exports).default,
  "nb-NO": _babelRuntimeHelpersEsmInteropRequireDefault($d57cd730bb11b14bdcd692e702bb0e60$exports).default,
  "nl-NL": _babelRuntimeHelpersEsmInteropRequireDefault($bd8f8fc2a02532c55851f18c8de3$exports).default,
  "pl-PL": _babelRuntimeHelpersEsmInteropRequireDefault($d8e1a561b4b79d4ead55e4ee5ea09970$exports).default,
  "pt-BR": _babelRuntimeHelpersEsmInteropRequireDefault($d479a80df73293910fe373596d18f$exports).default,
  "pt-PT": _babelRuntimeHelpersEsmInteropRequireDefault($d91b847a2bf9b6fb7cc187d839c725f$exports).default,
  "ro-RO": _babelRuntimeHelpersEsmInteropRequireDefault($f25e8d5f5e9099b97d639d4f299ba$exports).default,
  "ru-RU": _babelRuntimeHelpersEsmInteropRequireDefault($da94598d7d1c854d87360883488$exports).default,
  "sk-SK": _babelRuntimeHelpersEsmInteropRequireDefault($d1513dad87da1caa61156c979822ded2$exports).default,
  "sl-SI": _babelRuntimeHelpersEsmInteropRequireDefault($e16512e37a1c3ef90ecfc72d16793c1$exports).default,
  "sr-SP": _babelRuntimeHelpersEsmInteropRequireDefault($f0f0ea292848c1c22e92d1c71347950$exports).default,
  "sv-SE": _babelRuntimeHelpersEsmInteropRequireDefault($ddeb3363257d0b1fab7fb0169309987$exports).default,
  "tr-TR": _babelRuntimeHelpersEsmInteropRequireDefault($e41e18d940cc1fd6ce3b548eaf26f$exports).default,
  "uk-UA": _babelRuntimeHelpersEsmInteropRequireDefault($c7fbfea59f1f84c3fbdb550bd45e1a8d$exports).default,
  "zh-CN": _babelRuntimeHelpersEsmInteropRequireDefault($c5ee38283255212ee41b3baf5b8304d$exports).default,
  "zh-TW": _babelRuntimeHelpersEsmInteropRequireDefault($e4f38d4b06a7a74952e9f6dec2e6e20$exports).default
};
export function useDatePicker(props, state, ref) {
  let buttonId = useId();
  let dialogId = useId();
  let formatMessage = useMessageFormatter($c154dc72a1c6e7eac4dc4005915dd53b$var$intlMessages);
  let {
    labelProps,
    fieldProps,
    descriptionProps,
    errorMessageProps
  } = useField(_babelRuntimeHelpersEsmExtends({}, props, {
    labelElementType: 'span'
  }));
  let groupProps = $bf15f790f1b0bea8ba7f44d4056d095d$export$useDatePickerGroup(state, ref);
  let labelledBy = fieldProps['aria-labelledby'] || fieldProps.id;
  let {
    locale
  } = useLocale();
  let descProps = useDescription(state.formatValue(locale, {
    month: 'long'
  }));
  let ariaDescribedBy = [descProps['aria-describedby'], fieldProps['aria-describedby']].filter(Boolean).join(' ') || undefined;
  return {
    groupProps: mergeProps(groupProps, descProps, {
      role: 'group',
      'aria-disabled': props.isDisabled || null,
      'aria-labelledby': labelledBy,
      'aria-describedby': ariaDescribedBy
    }),
    labelProps: _babelRuntimeHelpersEsmExtends({}, labelProps, {
      onClick: () => {
        let focusManager = createFocusManager(ref);
        focusManager.focusFirst();
      }
    }),
    fieldProps,
    descriptionProps,
    errorMessageProps,
    buttonProps: _babelRuntimeHelpersEsmExtends({}, descProps, {
      id: buttonId,
      excludeFromTabOrder: true,
      'aria-haspopup': 'dialog',
      'aria-label': formatMessage('calendar'),
      'aria-labelledby': labelledBy + " " + buttonId,
      'aria-describedby': ariaDescribedBy
    }),
    dialogProps: {
      id: dialogId,
      'aria-labelledby': labelledBy + " " + buttonId
    }
  };
}
export const labelIds = new WeakMap();
export function useDateField(props, state, ref) {
  let {
    labelProps,
    fieldProps,
    descriptionProps,
    errorMessageProps
  } = useField(_babelRuntimeHelpersEsmExtends({}, props, {
    labelElementType: 'span'
  }));
  let groupProps = $bf15f790f1b0bea8ba7f44d4056d095d$export$useDatePickerGroup(state, ref);
  let {
    focusWithinProps
  } = useFocusWithin({
    onBlurWithin() {
      state.confirmPlaceholder();
    }

  });
  let formatter = useDateFormatter(state.getFormatOptions({
    month: 'long'
  }));
  let descProps = useDescription(state.value ? formatter.format(state.dateValue) : null);
  let segmentLabelledBy = fieldProps['aria-labelledby'] || fieldProps.id;
  let describedBy = [descProps['aria-describedby'], fieldProps['aria-describedby']].filter(Boolean).join(' ') || undefined;
  labelIds.set(state, {
    ariaLabelledBy: segmentLabelledBy,
    ariaDescribedBy: describedBy
  });
  return {
    labelProps: _babelRuntimeHelpersEsmExtends({}, labelProps, {
      onClick: () => {
        let focusManager = createFocusManager(ref);
        focusManager.focusFirst();
      }
    }),
    fieldProps: mergeProps(fieldProps, descProps, groupProps, focusWithinProps, {
      role: 'group',
      'aria-disabled': props.isDisabled || undefined,
      'aria-describedby': describedBy
    }),
    descriptionProps,
    errorMessageProps
  };
}

/*
 * Copyright 2020 Adobe. All rights reserved.
 * This file is licensed to you under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License. You may obtain a copy
 * of the License at http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under
 * the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR REPRESENTATIONS
 * OF ANY KIND, either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
// @ts-ignore
const $cde4cc2ec84ee652472d8c9e7126e8ce$var$intlMessages = {
  "ar-AE": _babelRuntimeHelpersEsmInteropRequireDefault($b935bd0cd08a5bbbb1abd3806a771dc4$exports).default,
  "bg-BG": _babelRuntimeHelpersEsmInteropRequireDefault($fd4c1baa70755ee27b55d9d185ef9a9$exports).default,
  "cs-CZ": _babelRuntimeHelpersEsmInteropRequireDefault($ec5372c287a16045d039aa0470ed9fb2$exports).default,
  "da-DK": _babelRuntimeHelpersEsmInteropRequireDefault($f6d6f24ad9d284dd48723518690d0e39$exports).default,
  "de-DE": _babelRuntimeHelpersEsmInteropRequireDefault($cc3534ef504f0b7371d8c5aa254d877f$exports).default,
  "el-GR": _babelRuntimeHelpersEsmInteropRequireDefault($ebc142984d7760b9cffe23548bb$exports).default,
  "en-US": _babelRuntimeHelpersEsmInteropRequireDefault($f9cbab65725c7cb01e69dde93bd9a$exports).default,
  "es-ES": _babelRuntimeHelpersEsmInteropRequireDefault($b069706710aa3fdbaa20a1b3449d63$exports).default,
  "et-EE": _babelRuntimeHelpersEsmInteropRequireDefault($dc294c753448ff9c1809bca75ab74d1$exports).default,
  "fi-FI": _babelRuntimeHelpersEsmInteropRequireDefault($d3f5f76480327eda035ed93c2$exports).default,
  "fr-FR": _babelRuntimeHelpersEsmInteropRequireDefault($b627132da032b4209b5582508dfe332$exports).default,
  "he-IL": _babelRuntimeHelpersEsmInteropRequireDefault($c3959c7b2e7e08ef514631ba3c2fdb$exports).default,
  "hr-HR": _babelRuntimeHelpersEsmInteropRequireDefault($ca3a95147a2664e1a3c49130ccfb87$exports).default,
  "hu-HU": _babelRuntimeHelpersEsmInteropRequireDefault($fa6b6e78fd909c4deb0805c4ff5df60$exports).default,
  "it-IT": _babelRuntimeHelpersEsmInteropRequireDefault($bb4837487a35e965bc77709590fda45$exports).default,
  "ja-JP": _babelRuntimeHelpersEsmInteropRequireDefault($f021a923ac58a1406a8f3f0bfd5f718$exports).default,
  "ko-KR": _babelRuntimeHelpersEsmInteropRequireDefault($e1a2895f7736c57623c5df88ed61$exports).default,
  "lt-LT": _babelRuntimeHelpersEsmInteropRequireDefault($ee477dd4ee39b2586e7d93e4241$exports).default,
  "lv-LV": _babelRuntimeHelpersEsmInteropRequireDefault($c216567e87e3bd12ecb2f27ce189a5b$exports).default,
  "nb-NO": _babelRuntimeHelpersEsmInteropRequireDefault($d57cd730bb11b14bdcd692e702bb0e60$exports).default,
  "nl-NL": _babelRuntimeHelpersEsmInteropRequireDefault($bd8f8fc2a02532c55851f18c8de3$exports).default,
  "pl-PL": _babelRuntimeHelpersEsmInteropRequireDefault($d8e1a561b4b79d4ead55e4ee5ea09970$exports).default,
  "pt-BR": _babelRuntimeHelpersEsmInteropRequireDefault($d479a80df73293910fe373596d18f$exports).default,
  "pt-PT": _babelRuntimeHelpersEsmInteropRequireDefault($d91b847a2bf9b6fb7cc187d839c725f$exports).default,
  "ro-RO": _babelRuntimeHelpersEsmInteropRequireDefault($f25e8d5f5e9099b97d639d4f299ba$exports).default,
  "ru-RU": _babelRuntimeHelpersEsmInteropRequireDefault($da94598d7d1c854d87360883488$exports).default,
  "sk-SK": _babelRuntimeHelpersEsmInteropRequireDefault($d1513dad87da1caa61156c979822ded2$exports).default,
  "sl-SI": _babelRuntimeHelpersEsmInteropRequireDefault($e16512e37a1c3ef90ecfc72d16793c1$exports).default,
  "sr-SP": _babelRuntimeHelpersEsmInteropRequireDefault($f0f0ea292848c1c22e92d1c71347950$exports).default,
  "sv-SE": _babelRuntimeHelpersEsmInteropRequireDefault($ddeb3363257d0b1fab7fb0169309987$exports).default,
  "tr-TR": _babelRuntimeHelpersEsmInteropRequireDefault($e41e18d940cc1fd6ce3b548eaf26f$exports).default,
  "uk-UA": _babelRuntimeHelpersEsmInteropRequireDefault($c7fbfea59f1f84c3fbdb550bd45e1a8d$exports).default,
  "zh-CN": _babelRuntimeHelpersEsmInteropRequireDefault($c5ee38283255212ee41b3baf5b8304d$exports).default,
  "zh-TW": _babelRuntimeHelpersEsmInteropRequireDefault($e4f38d4b06a7a74952e9f6dec2e6e20$exports).default
};
export function useDisplayNames() {
  let {
    locale
  } = useLocale();
  return useMemo(() => {
    // Try to use Intl.DisplayNames if possible. It may be supported in browsers, but not support the dateTimeField
    // type as that was only added in v2. https://github.com/tc39/intl-displaynames-v2
    try {
      // @ts-ignore
      return new Intl.DisplayNames(locale, {
        type: 'dateTimeField'
      });
    } catch (err) {
      return new $cde4cc2ec84ee652472d8c9e7126e8ce$var$DisplayNamesPolyfill(locale);
    }
  }, [locale]);
}

class $cde4cc2ec84ee652472d8c9e7126e8ce$var$DisplayNamesPolyfill {
  constructor(locale) {
    this.locale = void 0;
    this.dictionary = void 0;
    this.locale = locale;
    this.dictionary = new MessageDictionary($cde4cc2ec84ee652472d8c9e7126e8ce$var$intlMessages);
  }

  of(field) {
    return this.dictionary.getStringForLocale(field, this.locale);
  }

}

export function useDateSegment(props, segment, state, ref) {
  let enteredKeys = useRef('');
  let {
    locale,
    direction
  } = useLocale();
  let displayNames = useDisplayNames();
  let focusManager = useFocusManager();
  let textValue = segment.text;
  let options = useMemo(() => state.dateFormatter.resolvedOptions(), [state.dateFormatter]);
  let monthDateFormatter = useDateFormatter({
    month: 'long',
    timeZone: options.timeZone
  });
  let hourDateFormatter = useDateFormatter({
    hour: 'numeric',
    hour12: options.hour12,
    timeZone: options.timeZone
  });

  if (segment.type === 'month') {
    let monthTextValue = monthDateFormatter.format(state.dateValue);
    textValue = monthTextValue !== textValue ? textValue + " \u2013 " + monthTextValue : monthTextValue;
  } else if (segment.type === 'hour' || segment.type === 'dayPeriod') {
    textValue = hourDateFormatter.format(state.dateValue);
  }

  let {
    spinButtonProps
  } = useSpinButton({
    value: segment.value,
    textValue,
    minValue: segment.minValue,
    maxValue: segment.maxValue,
    isDisabled: props.isDisabled,
    isReadOnly: props.isReadOnly || !segment.isEditable,
    isRequired: props.isRequired,
    onIncrement: () => {
      enteredKeys.current = '';
      state.increment(segment.type);
    },
    onDecrement: () => {
      enteredKeys.current = '';
      state.decrement(segment.type);
    },
    onIncrementPage: () => {
      enteredKeys.current = '';
      state.incrementPage(segment.type);
    },
    onDecrementPage: () => {
      enteredKeys.current = '';
      state.decrementPage(segment.type);
    },
    onIncrementToMax: () => {
      enteredKeys.current = '';
      state.setSegment(segment.type, segment.maxValue);
    },
    onDecrementToMin: () => {
      enteredKeys.current = '';
      state.setSegment(segment.type, segment.minValue);
    }
  });
  let parser = useMemo(() => new NumberParser(locale, {
    maximumFractionDigits: 0
  }), [locale]);

  let backspace = () => {
    if (parser.isValidPartialNumber(segment.text) && !props.isReadOnly && !segment.isPlaceholder) {
      let newValue = segment.text.slice(0, -1);
      let parsed = parser.parse(newValue);

      if (newValue.length === 0 || parsed === 0) {
        state.clearSegment(segment.type);
      } else {
        state.setSegment(segment.type, parsed);
      }

      enteredKeys.current = newValue;
    } else if (segment.type === 'dayPeriod') {
      state.clearSegment(segment.type);
    }
  };

  let onKeyDown = e => {
    // Firefox does not fire selectstart for Ctrl/Cmd + A
    // https://bugzilla.mozilla.org/show_bug.cgi?id=1742153
    if (e.key === 'a' && (isMac() ? e.metaKey : e.ctrlKey)) {
      e.preventDefault();
    }

    if (e.ctrlKey || e.metaKey || e.shiftKey || e.altKey) {
      return;
    }

    switch (e.key) {
      case 'ArrowLeft':
        e.preventDefault();
        e.stopPropagation();

        if (direction === 'rtl') {
          focusManager.focusNext();
        } else {
          focusManager.focusPrevious();
        }

        break;

      case 'ArrowRight':
        e.preventDefault();
        e.stopPropagation();

        if (direction === 'rtl') {
          focusManager.focusPrevious();
        } else {
          focusManager.focusNext();
        }

        break;

      case 'Enter':
        e.preventDefault();
        e.stopPropagation();

        if (segment.isPlaceholder && !props.isReadOnly) {
          state.confirmPlaceholder(segment.type);
        }

        focusManager.focusNext();
        break;

      case 'Tab':
        break;

      case 'Backspace':
      case 'Delete':
        {
          // Safari on iOS does not fire beforeinput for the backspace key because the cursor is at the start.
          e.preventDefault();
          e.stopPropagation();
          backspace();
          break;
        }
    }
  }; // Safari dayPeriod option doesn't work...


  let {
    startsWith
  } = useFilter({
    sensitivity: 'base'
  });
  let amPmFormatter = useDateFormatter({
    hour: 'numeric',
    hour12: true
  });
  let am = useMemo(() => {
    let date = new Date();
    date.setHours(0);
    return amPmFormatter.formatToParts(date).find(part => part.type === 'dayPeriod').value;
  }, [amPmFormatter]);
  let pm = useMemo(() => {
    let date = new Date();
    date.setHours(12);
    return amPmFormatter.formatToParts(date).find(part => part.type === 'dayPeriod').value;
  }, [amPmFormatter]);

  let onInput = key => {
    if (props.isDisabled || props.isReadOnly) {
      return;
    }

    let newValue = enteredKeys.current + key;

    switch (segment.type) {
      case 'dayPeriod':
        if (startsWith(am, key)) {
          state.setSegment('dayPeriod', 0);
        } else if (startsWith(pm, key)) {
          state.setSegment('dayPeriod', 12);
        } else {
          break;
        }

        focusManager.focusNext();
        break;

      case 'day':
      case 'hour':
      case 'minute':
      case 'second':
      case 'month':
      case 'year':
        {
          if (!parser.isValidPartialNumber(newValue)) {
            return;
          }

          let numberValue = parser.parse(newValue);
          let segmentValue = numberValue;
          let allowsZero = segment.minValue === 0;

          if (segment.type === 'hour' && state.dateFormatter.resolvedOptions().hour12) {
            switch (state.dateFormatter.resolvedOptions().hourCycle) {
              case 'h11':
                if (numberValue > 11) {
                  segmentValue = parser.parse(key);
                }

                break;

              case 'h12':
                allowsZero = false;

                if (numberValue > 12) {
                  segmentValue = parser.parse(key);
                }

                break;
            }

            if (segment.value >= 12 && numberValue > 1) {
              numberValue += 12;
            }
          } else if (numberValue > segment.maxValue) {
            segmentValue = parser.parse(key);
          }

          if (isNaN(numberValue)) {
            return;
          }

          let shouldSetValue = segmentValue !== 0 || allowsZero;

          if (shouldSetValue) {
            state.setSegment(segment.type, segmentValue);
          }

          if (Number(numberValue + '0') > segment.maxValue || newValue.length >= String(segment.maxValue).length) {
            enteredKeys.current = '';

            if (shouldSetValue) {
              focusManager.focusNext();
            }
          } else {
            enteredKeys.current = newValue;
          }

          break;
        }
    }
  };

  let onFocus = () => {
    enteredKeys.current = '';
    scrollIntoView(getScrollParent(ref.current), ref.current); // Safari requires that a selection is set or it won't fire input events.
    // Since usePress disables text selection, this won't happen by default.

    ref.current.style.webkitUserSelect = 'text';
    let selection = window.getSelection();
    selection.collapse(ref.current);
    ref.current.style.webkitUserSelect = '';
  };

  let compositionRef = useRef(''); // @ts-ignore - TODO: possibly old TS version? doesn't fail in my editor...

  useEvent(ref, 'beforeinput', e => {
    e.preventDefault();

    switch (e.inputType) {
      case 'deleteContentBackward':
      case 'deleteContentForward':
        if (parser.isValidPartialNumber(segment.text) && !props.isReadOnly) {
          backspace();
        }

        break;

      case 'insertCompositionText':
        // insertCompositionText cannot be canceled.
        // Record the current state of the element so we can restore it in the `input` event below.
        compositionRef.current = ref.current.textContent; // Safari gets stuck in a composition state unless we also assign to the value here.
        // eslint-disable-next-line no-self-assign

        ref.current.textContent = ref.current.textContent;
        break;

      default:
        if (e.data != null) {
          onInput(e.data);
        }

        break;
    }
  });
  useEvent(ref, 'input', e => {
    let {
      inputType,
      data
    } = e;

    switch (inputType) {
      case 'insertCompositionText':
        // Reset the DOM to how it was in the beforeinput event.
        ref.current.textContent = compositionRef.current; // Android sometimes fires key presses of letters as composition events. Need to handle am/pm keys here too.
        // Can also happen e.g. with Pinyin keyboard on iOS.

        if (startsWith(am, data) || startsWith(pm, data)) {
          onInput(data);
        }

        break;
    }
  }); // Focus on mouse down/touch up to match native textfield behavior.
  // usePress handles canceling text selection.

  let {
    pressProps
  } = usePress({
    preventFocusOnPress: true,
    onPressStart: e => {
      if (e.pointerType === 'mouse') {
        e.target.focus();
      }
    },

    onPress(e) {
      if (e.pointerType !== 'mouse') {
        e.target.focus();
      }
    }

  }); // For Android: prevent selection on long press.

  useEvent(ref, 'selectstart', e => {
    e.preventDefault();
  }); // spinbuttons cannot be focused with VoiceOver on iOS.

  let touchPropOverrides = isIOS() || segment.type === 'timeZoneName' ? {
    role: 'textbox',
    'aria-valuemax': null,
    'aria-valuemin': null,
    'aria-valuetext': null,
    'aria-valuenow': null
  } : {};
  let {
    ariaLabelledBy,
    ariaDescribedBy
  } = labelIds.get(state); // Only apply aria-describedby to the first segment, unless the field is invalid. This avoids it being
  // read every time the user navigates to a new segment.

  let firstSegment = useMemo(() => state.segments.find(s => s.isEditable), [state.segments]);

  if (segment !== firstSegment && state.validationState !== 'invalid') {
    ariaDescribedBy = undefined;
  }

  let id = useId(props.id);
  let isEditable = !props.isDisabled && !props.isReadOnly && segment.isEditable;
  return {
    segmentProps: mergeProps(spinButtonProps, pressProps, _babelRuntimeHelpersEsmExtends({
      id
    }, touchPropOverrides, {
      'aria-controls': props['aria-controls'],
      // 'aria-haspopup': props['aria-haspopup'], // deprecated in ARIA 1.2
      'aria-invalid': state.validationState === 'invalid' ? 'true' : undefined,
      'aria-label': segment.type !== 'literal' ? displayNames.of(segment.type) : undefined,
      'aria-labelledby': ariaLabelledBy + " " + id,
      'aria-describedby': ariaDescribedBy,
      'aria-placeholder': segment.isPlaceholder ? segment.text : undefined,
      'aria-readonly': props.isReadOnly || !segment.isEditable ? 'true' : undefined,
      contentEditable: isEditable,
      suppressContentEditableWarning: isEditable,
      spellCheck: isEditable ? 'false' : undefined,
      autoCapitalize: isEditable ? 'off' : undefined,
      autoCorrect: isEditable ? 'off' : undefined,
      // Capitalization was changed in React 17...
      [parseInt(_react.version, 10) >= 17 ? 'enterKeyHint' : 'enterkeyhint']: isEditable ? 'next' : undefined,
      inputMode: props.isDisabled || segment.type === 'dayPeriod' || !isEditable ? undefined : 'numeric',
      tabIndex: props.isDisabled ? undefined : 0,
      onKeyDown,
      onFocus
    }))
  };
}
// @ts-ignore
const $eb0a25d35efaafa331308f687b4f492$var$intlMessages = {
  "ar-AE": _babelRuntimeHelpersEsmInteropRequireDefault($b935bd0cd08a5bbbb1abd3806a771dc4$exports).default,
  "bg-BG": _babelRuntimeHelpersEsmInteropRequireDefault($fd4c1baa70755ee27b55d9d185ef9a9$exports).default,
  "cs-CZ": _babelRuntimeHelpersEsmInteropRequireDefault($ec5372c287a16045d039aa0470ed9fb2$exports).default,
  "da-DK": _babelRuntimeHelpersEsmInteropRequireDefault($f6d6f24ad9d284dd48723518690d0e39$exports).default,
  "de-DE": _babelRuntimeHelpersEsmInteropRequireDefault($cc3534ef504f0b7371d8c5aa254d877f$exports).default,
  "el-GR": _babelRuntimeHelpersEsmInteropRequireDefault($ebc142984d7760b9cffe23548bb$exports).default,
  "en-US": _babelRuntimeHelpersEsmInteropRequireDefault($f9cbab65725c7cb01e69dde93bd9a$exports).default,
  "es-ES": _babelRuntimeHelpersEsmInteropRequireDefault($b069706710aa3fdbaa20a1b3449d63$exports).default,
  "et-EE": _babelRuntimeHelpersEsmInteropRequireDefault($dc294c753448ff9c1809bca75ab74d1$exports).default,
  "fi-FI": _babelRuntimeHelpersEsmInteropRequireDefault($d3f5f76480327eda035ed93c2$exports).default,
  "fr-FR": _babelRuntimeHelpersEsmInteropRequireDefault($b627132da032b4209b5582508dfe332$exports).default,
  "he-IL": _babelRuntimeHelpersEsmInteropRequireDefault($c3959c7b2e7e08ef514631ba3c2fdb$exports).default,
  "hr-HR": _babelRuntimeHelpersEsmInteropRequireDefault($ca3a95147a2664e1a3c49130ccfb87$exports).default,
  "hu-HU": _babelRuntimeHelpersEsmInteropRequireDefault($fa6b6e78fd909c4deb0805c4ff5df60$exports).default,
  "it-IT": _babelRuntimeHelpersEsmInteropRequireDefault($bb4837487a35e965bc77709590fda45$exports).default,
  "ja-JP": _babelRuntimeHelpersEsmInteropRequireDefault($f021a923ac58a1406a8f3f0bfd5f718$exports).default,
  "ko-KR": _babelRuntimeHelpersEsmInteropRequireDefault($e1a2895f7736c57623c5df88ed61$exports).default,
  "lt-LT": _babelRuntimeHelpersEsmInteropRequireDefault($ee477dd4ee39b2586e7d93e4241$exports).default,
  "lv-LV": _babelRuntimeHelpersEsmInteropRequireDefault($c216567e87e3bd12ecb2f27ce189a5b$exports).default,
  "nb-NO": _babelRuntimeHelpersEsmInteropRequireDefault($d57cd730bb11b14bdcd692e702bb0e60$exports).default,
  "nl-NL": _babelRuntimeHelpersEsmInteropRequireDefault($bd8f8fc2a02532c55851f18c8de3$exports).default,
  "pl-PL": _babelRuntimeHelpersEsmInteropRequireDefault($d8e1a561b4b79d4ead55e4ee5ea09970$exports).default,
  "pt-BR": _babelRuntimeHelpersEsmInteropRequireDefault($d479a80df73293910fe373596d18f$exports).default,
  "pt-PT": _babelRuntimeHelpersEsmInteropRequireDefault($d91b847a2bf9b6fb7cc187d839c725f$exports).default,
  "ro-RO": _babelRuntimeHelpersEsmInteropRequireDefault($f25e8d5f5e9099b97d639d4f299ba$exports).default,
  "ru-RU": _babelRuntimeHelpersEsmInteropRequireDefault($da94598d7d1c854d87360883488$exports).default,
  "sk-SK": _babelRuntimeHelpersEsmInteropRequireDefault($d1513dad87da1caa61156c979822ded2$exports).default,
  "sl-SI": _babelRuntimeHelpersEsmInteropRequireDefault($e16512e37a1c3ef90ecfc72d16793c1$exports).default,
  "sr-SP": _babelRuntimeHelpersEsmInteropRequireDefault($f0f0ea292848c1c22e92d1c71347950$exports).default,
  "sv-SE": _babelRuntimeHelpersEsmInteropRequireDefault($ddeb3363257d0b1fab7fb0169309987$exports).default,
  "tr-TR": _babelRuntimeHelpersEsmInteropRequireDefault($e41e18d940cc1fd6ce3b548eaf26f$exports).default,
  "uk-UA": _babelRuntimeHelpersEsmInteropRequireDefault($c7fbfea59f1f84c3fbdb550bd45e1a8d$exports).default,
  "zh-CN": _babelRuntimeHelpersEsmInteropRequireDefault($c5ee38283255212ee41b3baf5b8304d$exports).default,
  "zh-TW": _babelRuntimeHelpersEsmInteropRequireDefault($e4f38d4b06a7a74952e9f6dec2e6e20$exports).default
};
export function useDateRangePicker(props, state, ref) {
  let formatMessage = useMessageFormatter($eb0a25d35efaafa331308f687b4f492$var$intlMessages);
  let {
    labelProps,
    fieldProps,
    descriptionProps,
    errorMessageProps
  } = useField(_babelRuntimeHelpersEsmExtends({}, props, {
    labelElementType: 'span'
  }));
  let labelledBy = fieldProps['aria-labelledby'] || fieldProps.id;
  let {
    locale
  } = useLocale();
  let description = state.formatValue(locale, {
    month: 'long'
  });
  let descProps = useDescription(description);
  let startFieldProps = useLabels({
    'aria-label': formatMessage('startDate'),
    'aria-labelledby': labelledBy
  });
  let endFieldProps = useLabels({
    'aria-label': formatMessage('endDate'),
    'aria-labelledby': labelledBy
  });
  let buttonId = useId();
  let dialogId = useId();
  let groupProps = $bf15f790f1b0bea8ba7f44d4056d095d$export$useDatePickerGroup(state, ref);
  let {
    focusWithinProps
  } = useFocusWithin({
    onBlurWithin() {
      state.confirmPlaceholder();
    }

  });
  let ariaDescribedBy = [descProps['aria-describedby'], fieldProps['aria-describedby']].filter(Boolean).join(' ') || undefined;
  return {
    groupProps: mergeProps(groupProps, fieldProps, descProps, focusWithinProps, {
      role: 'group',
      'aria-disabled': props.isDisabled || null,
      'aria-describedby': ariaDescribedBy
    }),
    labelProps: _babelRuntimeHelpersEsmExtends({}, labelProps, {
      onClick: () => {
        let focusManager = createFocusManager(ref);
        focusManager.focusFirst();
      }
    }),
    buttonProps: _babelRuntimeHelpersEsmExtends({}, descProps, {
      id: buttonId,
      excludeFromTabOrder: true,
      'aria-haspopup': 'dialog',
      'aria-label': formatMessage('calendar'),
      'aria-labelledby': labelledBy + " " + buttonId,
      'aria-describedby': ariaDescribedBy
    }),
    dialogProps: {
      id: dialogId,
      'aria-labelledby': labelledBy + " " + buttonId
    },
    startFieldProps: _babelRuntimeHelpersEsmExtends({}, startFieldProps, {
      'aria-describedby': fieldProps['aria-describedby']
    }),
    endFieldProps: _babelRuntimeHelpersEsmExtends({}, endFieldProps, {
      'aria-describedby': fieldProps['aria-describedby']
    }),
    descriptionProps,
    errorMessageProps
  };
}
//# sourceMappingURL=module.js.map
